﻿@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using System.Threading
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive

@implements IAsyncDisposable

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IJSRuntime _jsRuntime
@inject IStringLocalizer<TasksArchive> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<!--suppress CssUnusedSymbol -->
<style>
    .cec-pane {
        position: absolute;
        top: 0; bottom: 0;
        left: 0; right: 0;
        width: 100%; height: 100%;
        border: none; border-radius: 0;
        padding: 0; margin: 0;
        background: #2e2e2e;
    }
    
    .cec-loading-pane {
        position: absolute;
        top: 0; bottom: 0;
        left: 0; right: 0;
        width: 100%; height: 100%;
        z-index: 5;
        
        display: flex;
        background: transparent;
        justify-content: center;
        padding: 0; margin: 0;
        
        backdrop-filter: blur(10px);
        -webkit-backdrop-filter: blur(10px);
    }
    
    #cec-editor {
        font-family: "SFMono-Regular", Consolas, "Liberation Mono", Menlo, Courier, monospace !important;
        background: transparent !important;
    }
    
    #cec-editor .ace_gutter {
        background: transparent !important;
    }
    
    .cec-fab {
        position: absolute;
        right: 20px; bottom: 20px;
        z-index: 2;
    }
</style>

<MudPaper Outlined="false" Elevation="0" Class="cec-pane">
    @if (_programmingTask is null)
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="100%"></MudSkeleton>
    }
    else if (!_currentUserCanSubmitSolution)
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="100%"></MudSkeleton>
        <MudPaper Outlined="false" Elevation="0" Class="cec-loading-pane">
            <MudPaper Outlined="false" Elevation="0" Style="background: transparent; text-align: center; margin-top: auto; margin-bottom: auto;">
                <MudIcon Icon="@Icons.Material.Outlined.Lock" Style="font-size: 4rem; color: #ffffff;" />
                <MudText Typo="Typo.body1" Style="font-weight: bold; color: #ffffff;">@_localizer["Доступ до завдання заблоковано"]</MudText>
            </MudPaper>
        </MudPaper>
    }
    else
    {
        <MudPaper Outlined="false" Elevation="0" Style="width: 100%; height: 100%; background: transparent; border-radius: 0;">
            <div id="cec-editor" style="width: 100%; height: 100%;"></div>
        </MudPaper>
        
        <MudMenu Class="cec-fab" ActivationEvent="@MouseEvent.MouseOver" AnchorOrigin="Origin.TopRight" TransformOrigin="Origin.BottomRight">
            <ActivatorContent>
                <MudFab Color="Color.Success" Icon="@Icons.Material.Filled.Code"
                        Size="Size.Medium" IconSize="Size.Medium"
                        Label="@_localizer["Надіслати"]"/>
            </ActivatorContent>
            <ChildContent>
                <MudMenuItem Icon="@Icons.Material.Outlined.PublishedWithChanges"
                             OnClick="@(() => _compilerSelectionDialogVisible = true)"
                >@_localizer["Змінити компілятор"]</MudMenuItem>

                <MudDivider/>
                
                <MudMenuItem Icon="@Icons.Material.Outlined.ImagesearchRoller"
                             OnClick="@(async () => await OnSubmitAsync(TaskSolution.SolutionVerificationType.SyntaxMode))"
                >@_localizer["Перевірка синтаксису"]</MudMenuItem>
                
                <MudMenuItem Icon="@Icons.Material.Outlined.SettingsSuggest" Disabled="true"
                >@_localizer["Зневадження програми"]</MudMenuItem>
                
                <MudMenuItem Icon="@Icons.Material.Outlined.Send"
                             OnClick="@(async () => await OnSubmitAsync(TaskSolution.SolutionVerificationType.ReleaseMode))"
                >@_localizer["Остаточне оцінювання"]</MudMenuItem>
            </ChildContent>
        </MudMenu>
    }
    
    @if (_isLoading)
    {
        <MudPaper Outlined="false" Elevation="0" Class="cec-loading-pane">
            <MudProgressCircular Color="Color.Secondary" Indeterminate="true"
                                 Style="width: 70px; height: 70px; margin-top: auto; margin-bottom: auto;"/>
        </MudPaper>
    }
</MudPaper>

<MudDialog @bind-IsVisible="_compilerSelectionDialogVisible" Options="@_compilerSelectionDialogOptions">
    <TitleContent>
        <MudText Typo="Typo.h6">
            <MudIcon Icon="@Icons.Material.Filled.PlaylistAddCheckCircle" Class="mr-3 mb-n1"/>
            @_localizer["Вибір компілятора"]
        </MudText>
    </TitleContent>
    <DialogContent>
        <MudSelect T="Guid" Label="@_localizer["Компілятор"]" Strict="true"
                   Variant="Variant.Outlined" AnchorOrigin="Origin.BottomCenter" Value="@_programmingTaskSubmission.CompilerId"
                   ValueChanged="@(async val => await OnCompilerSelectedAsync(val))" For="() => _programmingTaskSubmission.CompilerId">
            @foreach (var compiler in _supportedCompilers)
            {
                <MudSelectItem T="Guid" Value="@compiler.Id">@compiler.Title</MudSelectItem>
            }
        </MudSelect>
    </DialogContent>
    <DialogActions></DialogActions>
</MudDialog>

@code {
    private SemaphoreSlim _semaphore;
    private IJSObjectReference _jsModule;
    
    [Parameter] public Guid ProgrammingTaskId { get; set; }
    
    private Guid _currentUserId;
    private UserType _currentUserType;
    private bool _currentUserCanSubmitSolution;

    private bool _isLoading;
    
    private ProgrammingTaskDetails _programmingTask;
    private SubmissionDetails _programmingTaskSubmission;
    
    private List<Compiler> _supportedCompilers;
    private bool _compilerSelectionDialogVisible;
    private DialogOptions _compilerSelectionDialogOptions = new()
    {
        CloseButton = true, DisableBackdropClick = true,
        FullWidth = true, MaxWidth = MaxWidth.ExtraSmall,
        Position = DialogPosition.Center
    };

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        _semaphore = new SemaphoreSlim(1, 1);
        _jsModule = null;
        
        _currentUserId = await GetCurrentUserIdAsync();
        _currentUserType = await GetUserTypeAsync(_currentUserId);
        _currentUserCanSubmitSolution = false;
        
        _programmingTask = null;

        _compilerSelectionDialogVisible = false;
        
        async Task<Guid> GetCurrentUserIdAsync()
        {
            var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
            return new Guid(_userManager.GetUserId(authenticationState.User));
        }
        
        async Task<UserType> GetUserTypeAsync(Guid userId)
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            return await databaseContext.Users.AsNoTracking()
                .Where(u => u.Id == userId)
                .Select(s => s.Type)
                .FirstAsync();
        }
    }

    protected override async Task OnParametersSetAsync()
    {
        _isLoading = true;
        StateHasChanged();

        try
        {
            // Create a new instance of the database context
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            
            // Check whether requested task exists
            if (!await databaseContext.ProgrammingTasks.AnyAsync(t => t.Id == ProgrammingTaskId))
            {
                _programmingTask = new ProgrammingTaskDetails();
                _currentUserCanSubmitSolution = false;
                return;
            }
            
            // Check whether programming task is accessible
            if (!await VerifyTaskIsAccessible(databaseContext, _currentUserType))
            {
                _snackbar.Add(_localizer["Доступ до цього завдання заблоковано!"], Severity.Error);
                _currentUserCanSubmitSolution = false;
            }
            else { _currentUserCanSubmitSolution = true; }
            
            /*
             * Check whether there are any waiting or in-progress solution
             * submissions, created by current user for the specified task.
             */
            if (_currentUserCanSubmitSolution && await HasPreviousActiveSubmissionsAsync(databaseContext, true))
                _currentUserCanSubmitSolution = false;
            
            /*
             * If current user has access to the task, fetch
             * information about that task, supported compilers
             * list, initialize other required dependencies
             * and check whether required compiler is enabled.
             */

            if (!_currentUserCanSubmitSolution)
            {
                _programmingTask = new ProgrammingTaskDetails();
                return;
            }
            
            // Get details about programming task
            _programmingTask = await GetProgrammingTaskInformationAsync(databaseContext);
            _supportedCompilers = await FetchSupportedCompilersListAsync(databaseContext);
            
            // Check whether required compiler for the task is accessible
            if (!_programmingTask.RequiredCompilerEnabled)
            {
                _currentUserCanSubmitSolution = false;
                _snackbar.Add(_localizer[
                    "Компілятор, на якому написаний авторський розв'язок завдання, зараз недоступний. " +
                    "Можливість відправлення розв'язків до цього завдання заблоковано."],
                    Severity.Error, options => options.CloseAfterNavigation = false);
            }
            
            // Get information about previous (or new) submission of the current user for this task
            _programmingTaskSubmission = await GetProgrammingTaskSubmissionDetailsAsync(databaseContext);
        }
        finally
        {
            _isLoading = false;
            StateHasChanged();
        }
        
        // ReSharper disable once VariableHidesOuterVariable
        async Task<bool> VerifyTaskIsAccessible(OvertestDatabaseContext databaseContext, UserType currentUserType)
        {
            if (currentUserType == UserType.SuperUser)
                return true;

            return await databaseContext.ProgrammingTasks.AnyAsync(
                t => t.Id == ProgrammingTaskId && t.Enabled);
        }
        
        // ReSharper disable once VariableHidesOuterVariable
        async Task<ProgrammingTaskDetails> GetProgrammingTaskInformationAsync(OvertestDatabaseContext databaseContext)
        {
            return await databaseContext.ProgrammingTasks.AsNoTracking()
                .Include(i => i.RequiredCompiler)
                .Where(t => t.Id == ProgrammingTaskId)
                .Select(s => new ProgrammingTaskDetails
                {
                    Enabled = s.Enabled,
                    RequiredCompilerId = s.RequiredCompilerId,
                    RequiredCompilerEnabled = s.RequiredCompiler.Enabled
                }).FirstAsync();
        }
        
        // ReSharper disable once VariableHidesOuterVariable
        async Task<List<Compiler>> FetchSupportedCompilersListAsync(OvertestDatabaseContext databaseContext)
        {
            return await databaseContext.Compilers.AsNoTracking()
                .Where(c => c.Enabled)
                .Select(s => new Compiler
                {
                    Id = s.Id,
                    Title = s.Title,
                    SyntaxHighlighter = s.SyntaxHighlighter
                }).ToListAsync();
        }
        
        // ReSharper disable once VariableHidesOuterVariable
        async Task<SubmissionDetails> GetProgrammingTaskSubmissionDetailsAsync(OvertestDatabaseContext databaseContext)
        {
            // Try to get latest submission for this task, created by current user
            var details = await databaseContext.ProgrammingTaskSolutions.AsNoTracking()
                .Where(s => s.ProgrammingTaskId == ProgrammingTaskId)
                .Where(s => s.AuthorId == _currentUserId)
                .OrderByDescending(order => order.Created)
                .Select(s => new SubmissionDetails
                {
                    SourceCode = s.SourceCode,
                    CompilerId = s.CompilerId,
                    VerificationType = s.VerificationType
                }).FirstOrDefaultAsync();
            
            // Populate submission details if there are no any previous submissions
            details ??= new SubmissionDetails
            {
                SourceCode = string.Empty,
                CompilerId = _programmingTask.RequiredCompilerId,
                VerificationType = TaskSolution.SolutionVerificationType.SyntaxMode
            };
            
            // Return details of the performed operation
            return details;
        }
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);
        
        if (_jsModule is not null)
            return;

        if (_programmingTask is null || !_currentUserCanSubmitSolution)
            return;

        _isLoading = true;
        StateHasChanged();

        try
        {
            // Import CEC javascript module
            _jsModule = await _jsRuntime.InvokeAsync<IJSObjectReference>(
                identifier: "import", args: "./assets/js/integrated_cec.module.js");
            
            // Invoke CEC initialization process
            await _jsModule.InvokeVoidAsync("cec_initialize", "cec-editor");

            await PassPreviousSubmissionDetailsAsync();

            async Task PassPreviousSubmissionDetailsAsync()
            {
                if (!string.IsNullOrWhiteSpace(_programmingTaskSubmission.SourceCode))
                {
                    // Pass source code of previous submission to the editor
                    await _jsModule.InvokeVoidAsync("cec_set_code", "cec-editor", _programmingTaskSubmission.SourceCode);
                }

                await OnCompilerSelectedAsync();
            }
        }
        catch (Exception) { /* Ignore all exceptions */ }
        finally
        {
            _isLoading = false;
            StateHasChanged();
        }
    }
    
    async ValueTask IAsyncDisposable.DisposeAsync()
    {
        if (_jsModule is not null)
            await _jsModule.DisposeAsync();
    }

    private async Task<bool> HasPreviousActiveSubmissionsAsync(
        OvertestDatabaseContext databaseContext, bool showMessageToUser = false)
    {
        var databaseQuery = databaseContext.ProgrammingTaskSolutions.Where(s =>
            s.ProgrammingTaskId == ProgrammingTaskId && s.AuthorId == _currentUserId &&
            s.VerificationStatus != TaskSolution.SolutionVerificationStatus.Verified);
        
        if (!await databaseQuery.AnyAsync())
            return false;
        
        if (!showMessageToUser)
            return true;
        
        var lastActiveSubmissionId = await databaseQuery
            .OrderByDescending(order => order.Created)
            .AsNoTracking().Select(s => s.Id).FirstOrDefaultAsync();
        
        _snackbar.Add(_localizer[
            "Ви вже направили розв'язок до цього завдання на перевірку. " +
            "Зачекайте на результати перевірки і повторіть вашу спробу, " +
            "або перейдіть до вашого попереднього розв'язку."], Severity.Warning, options =>
            {
                options.RequireInteraction = true;
                options.ShowCloseIcon = true;
                options.Action = _localizer["Переглянути"];
                options.ActionVariant = Variant.Filled;
                options.ActionColor = Color.Primary;
                options.Onclick = async _ =>
                {
                    _navigationManager.NavigateTo($"/tasks/solutions/view/{lastActiveSubmissionId}");
                    await Task.CompletedTask;
                };
            });

        return true;
    }

    private async Task OnCompilerSelectedAsync(Guid? selectedValue = null)
    {
        _compilerSelectionDialogVisible = false;

        if (_isLoading)
            return;
        
        if (selectedValue.HasValue)
            _programmingTaskSubmission.CompilerId = selectedValue.Value;
        
        if (_supportedCompilers.All(c => c.Id != _programmingTaskSubmission.CompilerId))
            _programmingTaskSubmission.CompilerId = _programmingTask.RequiredCompilerId;

        var compilerSyntaxHighlightingMode = _supportedCompilers
            .Where(c => c.Id == _programmingTaskSubmission.CompilerId)
            .Select(s => s.SyntaxHighlighter).First();
        
        // Ensure code editor mode set
        await _jsModule.InvokeVoidAsync("cec_set_mode", "cec-editor", compilerSyntaxHighlightingMode);
        
        if (selectedValue.HasValue)
            StateHasChanged();
    }
    
    private async Task OnSubmitAsync(TaskSolution.SolutionVerificationType verificationType)
    {
        if (_isLoading)
            return;
        
        await _semaphore.WaitAsync();
        try
        {
            _isLoading = true;
            StateHasChanged();
            
            // Get source code from Ace.js code editor
            _programmingTaskSubmission.SourceCode = await _jsModule.InvokeAsync<string>(
                identifier: "cec_get_code", args: "cec-editor") ?? string.Empty;
            // Trim all ends of the source code from special characters and whitespaces
            _programmingTaskSubmission.SourceCode = _programmingTaskSubmission.SourceCode.Trim();
            
            // TODO: Limit length of the source code
            
            // Don't allow to send "empty" solutions
            if (string.IsNullOrEmpty(_programmingTaskSubmission.SourceCode))
            {
                _snackbar.Add(_localizer["Сирцевий код розв'язку не може бути пустим!"],
                    Severity.Error, options => options.SnackbarVariant = Variant.Outlined);
                return;
            }
            
            // Create a new instance of the database context
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            
            // Don't allow to submit a new solution when there are any active submissions
            if (await HasPreviousActiveSubmissionsAsync(databaseContext, true))
                return;
            
            // If it is a release verification mode, remove all previous submissions
            await DeletePreviousSubmissionsAsync(databaseContext);
            
            // Create a new submission and get it's ID
            var createdSubmissionId = await CreateNewSubmissionAsync(databaseContext);
            
            // Navigate to verification results page
            _navigationManager.NavigateTo($"/tasks/solutions/view/{createdSubmissionId}");

            async Task DeletePreviousSubmissionsAsync(OvertestDatabaseContext dbContext)
            {
                // Delete previous submissions only when release mode is specified
                if (verificationType != TaskSolution.SolutionVerificationType.ReleaseMode)
                    return;
                
                // Get a db-ready objects for deletion
                var previousSubmissionsList = await dbContext.ProgrammingTaskSolutions
                    .Where(s => s.AuthorId == _currentUserId)
                    .Where(s => s.ProgrammingTaskId == ProgrammingTaskId)
                    .Select(s => new TaskSolution { Id = s.Id, VerificationStatus = s.VerificationStatus })
                    .AsNoTracking().ToListAsync();
                
                // Delete all previous submissions for this task, created by the current user
                dbContext.ProgrammingTaskSolutions.RemoveRange(previousSubmissionsList);
                
                // Save changes made to the database
                await dbContext.SaveChangesAsync();
            }
            
            async Task<Guid> CreateNewSubmissionAsync(OvertestDatabaseContext dbContext)
            {
                // Create a new submission object
                var submission = new TaskSolution
                {
                    AuthorId = _currentUserId,
                    ProgrammingTaskId = ProgrammingTaskId,

                    Created = DateTime.UtcNow,
                    VerificationType = verificationType,
                    SourceCode = _programmingTaskSubmission.SourceCode,
                    CompilerId = _programmingTaskSubmission.CompilerId
                };
                // Add a new submission to the database
                await dbContext.ProgrammingTaskSolutions.AddAsync(submission);
                // Save changes made to the database
                await dbContext.SaveChangesAsync();
                // Return newly-created submission's ID
                return submission.Id;
            }
        }
        catch (Exception)
        {
            _isLoading = false;
            StateHasChanged();
            _snackbar.Add(_localizer[
                "При спробі відправлення запиту на перевірку розв'язку виникла непередбачувана помилка. " +
                "Будь ласка, повторіть вашу спробу трохи пізніше, або зв'яжіться зі своїм куратором!"], Severity.Error);
        }
        finally
        {
            _semaphore.Release();
            _isLoading = false;
            StateHasChanged();
        }
    }
    
    private class ProgrammingTaskDetails
    {
        public bool Enabled { get; set; }
        public Guid RequiredCompilerId { get; set; }
        public bool RequiredCompilerEnabled { get; set; }
    }
    
    private class SubmissionDetails
    {
        public string SourceCode { get; set; }
        public Guid CompilerId { get; set; }
        public TaskSolution.SolutionVerificationType VerificationType { get; set; }
    }
}